/**
 * CONFIG: Translate
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .config( Config )
    .run( Run );

  function Config( $translateProvider ) {
    $translateProvider.useStaticFilesLoader( {
      files: [
        {
          prefix: 'common/locale/',
          suffix: '.json'
        }
      ]
    } );

    $translateProvider
      .registerAvailableLanguageKeys( [ 'en', 'zh' ], {
        'en_US': 'en',
        'en_UK': 'en',
        'en-US': 'en',
        'en-UK': 'en',
        'zh_CN': 'zh',
        'zh-CN': 'zh',
        '*': 'en'
      } )
      .preferredLanguage( 'en' )
      .fallbackLanguage( 'en' );
  }

  function Run( $ionicPlatform, $translate ) {
    $ionicPlatform.ready( function() {
      if ( navigator.globalization ) {
        navigator.globalization.getPreferredLanguage( function( language ) {
          var prefix = language.value.split( '-' )[ 0 ];
          $translate.use( prefix );
        }, null );
      }
    } );
  }
} )();
