/**
 * CONTROLLER: AppController
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';

  angular
    .module( 'lng' )
    .controller( 'AppController', AppController );

  function AppController( $log, $scope, $rootScope, SettingsService, Restangular, VERSION ) {
    var deregisterToastInfo,
      deregisterToastSuccess,
      deregisterToastError,
      settings = SettingsService.getSettings();

    // App configuration
    $rootScope.app = { title: 'KLNG' };

    // Set base API url
    Restangular.setBaseUrl( settings.ENDPOINT );
    Restangular.setDefaultHeaders( { 'x-requested-with': 'ct-mobile', 'x-version': VERSION.number } );
    // Toast
    deregisterToastInfo = $rootScope.$on( 'toast:info', toastnInfo );
    deregisterToastSuccess = $rootScope.$on( 'toast:success', toastSuccess );
    deregisterToastError = $rootScope.$on( 'toast:error', toastError );

    $scope.$on( '$destroy', function() {
      deregisterToastInfo();
      deregisterToastSuccess();
      deregisterToastError();
    } );

    ////////////

    function toastnInfo( event, msg ) {
      try {
        window.plugins.toast.showLongBottom( msg );
      } catch ( error ) {
        console.error( error );
      }
    }

    function toastSuccess( event, msg ) {
      try {
        window.plugins.toast.showShortBottom( msg );
      } catch ( error ) {
        console.error( error );
      }
    }

    function toastError( event, msg ) {
      $log.error( msg );
      try {
        window.plugins.toast.showLongBottom( msg );
      } catch ( error ) {
        console.error( error );
      }
    }
  }

} )();
