/**
 * SERVICE: SettingsService
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';

  angular
    .module( 'lng' )
    .factory( 'SettingsService', SettingsService );

  function SettingsService( Restangular, ENDPOINTS ) {
    var defaultCommo = JSON.parse( localStorage.getItem( 'current_commodity' ) ) || 'lng',
      commodities = ENDPOINTS;

    return {
      getSettings: getSettings,
      setCommodity: setCommodity
    };

    function getSettings() { return commodities[ defaultCommo ]; }

    function setCommodity( commo ) {
      defaultCommo = commo;
      Restangular.setBaseUrl( commodities[ defaultCommo ].ENDPOINT );
    }
  }

} )();
