/**
 * Installation HELPER
 * Not an angular service as it's used within other non angular module.
 */

( function( global ) {
  'use strict';

  var INSTALLATION_MAIN_TYPE = {
    'OPEC Refinery': 'Export',
    'Crude Oil Production': 'Export',
    'Crude Oil Export Terminal': 'Export',
    'Oil Product Export Terminal': 'Export',
    'Oil Export Terminal': 'Export',
    'LPG Production': 'Export',
    'LPG Chemicals Export Terminal': 'Export',
    'LPG Export Terminal': 'Export',
    'LPG Multi Purpose Export Terminal': 'Export',
    'Ammonia Export Terminal': 'Export',
    'Export': 'Export',

    'Non OPEC Refinery': 'Import',
    'Crude Oil Import Terminal': 'Import',
    'Oil Product Import Terminal': 'Import',
    'Oil Import Terminal': 'Import',
    'Crude Oil Consumption': 'Import',
    'LPG Cracker': 'Import',
    'LPG Chemicals Import Terminal': 'Import',
    'LPG Multi Purpose Import Terminal': 'Import',
    'LPG Import Terminal': 'Import',
    'LPG Consumption': 'Import',
    'Ammonia Import Terminal': 'Import',
    'Import': 'Import',

    'Shipyard': 'Shipyard',

    'Anchorage': 'Anchorage'
  };

  global.installationHelper = ( global.module || {} ).exports = {
    getMainType: getMainType
  };


  ////////////

  /**
   * Helper to get main type of an installation
   * and be able to handle icons, texts and classes.
   * @param  {string} type - original installation type
   * @return {string}      - main installation type
   */
  function getMainType( type ) {
    return INSTALLATION_MAIN_TYPE[ type ];
  }

} )( this );
