( function() {

  'use strict';

  angular
    .module( 'lng' )
    .controller( 'HomeMapController', HomeMapController );

  function HomeMapController( $scope, LngMapCacheService, VoyageCalculatorService ) {
    var vm = this,
      ionicViewAfterEnter;

    this.mapClazz = 'map-empty';
    this.VoyageCalculatorService = VoyageCalculatorService;

    if ( VoyageCalculatorService.result ) {
      LngMapCacheService.refresh()
      .then( function() {
        var waypoints;
        LngMapCacheService.unselectVessel();
        if ( VoyageCalculatorService.removeTrack ) {
          VoyageCalculatorService.removeTrack();
          VoyageCalculatorService.removeTrack = undefined;
        }
        waypoints = VoyageCalculatorService.result.waypoints;
        VoyageCalculatorService.removeTrack = LngMapCacheService.addVoyageTrack( waypoints );
        vm.origin = VoyageCalculatorService.origin;
        vm.destination = VoyageCalculatorService.destination;
        vm.distance = VoyageCalculatorService.result.distance;
        vm.duration = VoyageCalculatorService.result.duration;
        vm.mapClazz = vm.duration ? 'map-voyage' : 'map-empty';
      } );
    }

    ionicViewAfterEnter = $scope.$on( '$ionicView.afterEnter', function() { ionic.trigger( 'resize' ); } );

    $scope.$on( '$destroy', ionicViewAfterEnter );
  }

  HomeMapController.prototype.onVoyageCalcResultAction = function onVoyageCalcResultAction( action ) {
    switch ( action ) {
      case 'close': {
        this.VoyageCalculatorService.removeTrack();
        this.VoyageCalculatorService.removeTrack = undefined;
        this.VoyageCalculatorService.clear();
        this.mapClazz = 'map-empty';
        break;
      }
      default: {
        console.info( 'Action ' + action + ' is not managed.' );
      }
    }
  };

} )();
