/**
 * CONTROLLER: MapVesselController
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .controller( 'MapVesselController', MapVesselController );

  function MapVesselController( $stateParams, LngMapCacheService, VesselService, VoyageCalculatorService ) {

    var zoom = $stateParams.zoom === 'true';

    LngMapCacheService.refresh()
      .then( function() {
        VesselService.getById( $stateParams.id )
        .then( function( vessel ) {
          LngMapCacheService.unselectVessel();
          LngMapCacheService.selectVessel( vessel, zoom );

          if ( VoyageCalculatorService.removeTrack ) {
            VoyageCalculatorService.removeTrack();
            VoyageCalculatorService.removeTrack = undefined;
          }
        } );
      } );

  }

} )();
