/**
 * ROUTE: session.map.vessel
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .config( Routing );

  function Routing( $stateProvider ) {
    $stateProvider
      .state( 'session.map.vessel', {
      // Don't cache this view, otherwise enter() method of vessel.controller.js won't be used
      // and neither vessel tooltip nor vessel track will be displayed
      // This is required as we use ionic cache for other views
      // @see: http://bit.ly/1MSPSlh (section "caching")
        cache: false,
        url: '/vessel/:id?zoom',
        data: { requireAuth: true },
        views: {
          tooltip: {
            template: '<ion-view><ion-nav-title><i class="fa fa-globe"></i> <span>Map</span></ion-nav-title><ion-nav-buttons side="left"><img class="logo-no-text" src="./img/kpler_logo_no_text_white.png"/></ion-nav-buttons> <ion-nav-buttons side="right"><kpler-logo></kpler-logo></ion-nav-buttons> </ion-view>',
            controller: 'MapVesselController'
          }
        },
        onExit: function( LngMapCacheService ) { LngMapCacheService.unselectVessel(); }
      } );
  }

} )();
