/**
 * DIRECTIVE: playerActivity
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'playerActivity', playerActivity );

  function playerActivity() {
    var directive = {
      restrict: 'E',
      scope: {},
      bindToController: {
        promise: '=',
        type: '@'
      },
      templateUrl: 'app/session/player/activity/player-activity.html',
      controller: PlayerActivityController,
      controllerAs: 'vm'
    };

    return directive;

    ////////////

    /* @ngInject */
    function PlayerActivityController( TrackService ) {

      var self = this;

      this.promise
        .then( track )
        .then( assignEntity );

      ////////////

      function track( entity ) {
        var title = self.type + ' ' + entity.name + ' (' + entity.id + ') - Activity',
          trackObj = {
            route: self.type + '/Activity',
            title: title
          };
        trackObj[ self.type + '_id' ] = entity.id;
        trackObj[ self.type + '_name' ] = entity.name;

        TrackService.track( trackObj );

        return entity;
      }

      function assignEntity( entity ) {
        self.entity = entity;
        self.activeControlledFleet = countActiveVessel( self.entity.controlledFleet.vessels );
        self.activeOwnedFleet = countActiveVessel( self.entity.ownedFleet.vessels );

        return entity;
      }

      function countActiveVessel( vessels ) {
        var count = 0;

        angular.forEach( vessels, function( vessel ) {
          if ( vessel && vessel.vessel.status === 'Active' ) { count++; }
        } );
        return count;
      }
    }
  }

} )();
