( function() {
  'use strict';


  angular
    .module( 'lng' )
    .controller( 'SessionController', SessionController );

  function SessionController( $rootScope, $scope, $state, LoginService ) {
    var vm = this,
      // Manage new other message
      destroyOtherMessage = $rootScope.$on( 'teamboard:newmessage-other', function() { ++vm.newMessagesCount; } ),
      destroyResetMessage = $rootScope.$on( 'teamboard:reset', function() { vm.newMessagesCount = 0; } );

    this.hasTeamboardPermission = LoginService.getAuth().user.permissions.indexOf( 'teamboard' ) > -1;

    // Exposing it to the view so that we can use $state.go for ui-sref buggy case...
    this.$state = $state;

    $scope.$on( '$destroy', function() {
      destroyOtherMessage();
      destroyResetMessage();
    } );

  }
} )();
