/**
 * ROUTE: skeleton
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .config( Routing );

  function Routing( $stateProvider ) {
    $stateProvider
      .state( 'session', {
        abstract: true,
        cache: false,
        url: '/home',
        data: { requireAuth: true },
        resolve: {
          availableUnits: function( MulticommoService ) {
            return MulticommoService.getAvailableUnits()
              .then( function( units ) {
                // Temporarily drop units for energy dimension
                // @todo: <non-ready> - Remove once energy data are ready
                _.remove( units, function( unit ) { return ( unit.dimension === 'energy' ) || ( unit.dimension === 'volume_gas' ); } );
                localStorage.setItem( 'availableUnits', JSON.stringify( units ) );
                return units;
              } );
          }
        },
        templateUrl: 'app/session/session.html',
        controller: 'SessionController as $ctrl'
      } );
  }

} )();
