( function( global ) {
    'use strict';

    global.displayHelper = ( global.module || {} ).exports = {
        isCurrentlyTracked: isCurrentlyTracked,
        isCurrentCargoTracked: isCurrentCargoTracked,
        getFlattenedAncestorIdsFromVoyageProducts: getFlattenedAncestorIdsFromVoyageProducts,
    };


    ////////////

    var currentCommo = JSON.parse( localStorage.getItem( 'current_commodity' ) )

    function getFlattenedAncestorIdsFromVoyageProducts(
        voyageProducts
    ) {
        if ( !voyageProducts ) {
            return [];
        }
        return voyageProducts
            .flatMap( function( x ) { return x.ancestors || []; } )
            .map( function( x ) { return x.id; } )
            .filter( function( x, index, array ) { return index === array.indexOf(x); } );
    };

    function getFlattenedAncestorIdsFromCurrentCargo( currentCargo ) {
        if ( !currentCargo.products ) {
            return [];
        }

        return currentCargo.products
            .flatMap( function( x ) { return x.ancestors; } )
            .map( function( x ) { return x.id; } )
            .filter( function( x, index, array ) { return index === array.indexOf(x); } );
    };

    function isCurrentlyTracked( productAncestorIds ) {
        if ( currentCommo === 'lng' ) { return true; }
        return productAncestorIds.length !== 0;
    }

    function isCurrentCargoTracked( currentCargo ) {
        return isCurrentlyTracked( getFlattenedAncestorIdsFromCurrentCargo( currentCargo ) );
    }

} )( this );