/**
 * Text Translate Helper
 * @author  Jin
 */

( function( global ) {
  'use strict';

  var textTranslateHelper = {
    translateStatus: translateStatus,
    translateType: translateType,
    translateLoginError: translateLoginError
  };

  global.textTranslateHelper = ( global.module || {} ).exports = textTranslateHelper;

  ////////////

  function translateStatus( status ) {
    switch ( status ) {
      case 'Active':
        return '_COMMON.STATUS.ACTIVE';
      case 'Speculative':
        return '_COMMON.STATUS.SPECULATIVE';
      case 'Approved':
        return '_COMMON.STATUS.APPROVED';
      case 'Under Construction':
        return '_COMMON.STATUS.UNDER_CONSTRUCTION';
      case 'Planned and Proposed':
        return '_COMMON.STATUS.PLANNED';
      case 'Suspended':
        return '_COMMON.STATUS.SUSPEND';
      case 'Decommissioned':
        return '_COMMON.STATUS.DECOMMISSIONED';
      case 'Inactive':
        return '_COMMON.STATUS.INACTIVE';
      case 'Ballast':
        return '_COMMON.STATUS.BALLAST';
      case 'Loaded':
        return '_COMMON.STATUS.LOADED';
      default:
        return '_COMMON.STATUS.DEFAULT';

    }
  }

  function translateType( type ) {
    switch ( global.installationHelper.getMainType( type ) ) {
      case 'Import':
        return '_COMMON.TYPE.IMPORT';
      case 'Export':
        return '_COMMON.TYPE.EXPORT';
      case 'Shipyard':
        return '_COMMON.TYPE.SHIPYARD';
      case 'Anchorage':
        return '_COMMON.TYPE.ANCHORAGE';
      default:
        return '_COMMON.TYPE.DEFAULT';
    }
  }

  function translateLoginError( code ) {
    switch ( code ) {
      case '0001':
        return 'APP.START.LOGIN.WRONG_CREDENTIALS';
      case '0002':
        return 'APP.START.LOGIN.USER_EXPIRED';
      case '0003':
        return 'APP.START.LOGIN.USER_SUSPENDED';
      case '0004':
        return 'APP.START.LOGIN.NO_MOBILE_ACCESS';
      case '0005':
        return 'APP.START.LOGIN.NO_WEB_ACCESS';
      case '0006':
        return 'APP.START.LOGIN.USER_NOT_FOUND';
      case '0007':
        return 'APP.START.LOGIN.USER_BLOCKED';
      default:
        return 'APP.START.LOGIN.DEFAULT_ERROR';
    }
  }
} )( this );
