/**
 * INJECTOR: Token
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';

  angular
    .module( 'lng' )
    .factory( 'AuthInterceptor', AuthInterceptor )
    .config( InjectAuth );

  function AuthInterceptor( $injector ) {
    return { 'request': addAuthHeader };

    ////////////

    function addAuthHeader( config ) {
      var LoginService = $injector.get( 'LoginService' ),
        auth = LoginService.getAuth();
      if ( auth ) { config.headers.Authorization = auth.token; }
      return config;
    }
  }

  function InjectAuth( $httpProvider ) { $httpProvider.interceptors.push( 'AuthInterceptor' ); }

} )();
