/**
 * DIRECTIVE: contracts
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'contracts', contracts );

  function contracts() {
    var directive = {
      restrict: 'E',
      scope: {},
      bindToController: {
        promise: '=',
        type: '@'
      },
      templateUrl: 'components/contracts/contracts.html',
      controller: ContractsController,
      controllerAs: 'vm'
    };

    return directive;


    ////////////

    /* @ngInject */
    function ContractsController( TrackService ) {

      var self = this;

      this.promise
        .then( track )
        .then( function( entity ) {
          self.contracts = entity.contracts;
          self.hasContracts = !( _.isEmpty( entity.contracts ) );
        } );

      ////////////

      function track( entity ) {
        var title = self.type + ' ' + entity.name + ' (' + entity.id + ') - Contracts',
          trackObj = {
            route: self.type + '/contracts',
            title: title
          };
        trackObj[ self.type + '_id' ] = entity.id;
        trackObj[ self.type + '_name' ] = entity.name;

        TrackService.track( trackObj );
        return entity;
      }

    }
  }

} )();
