/**
 * DIRECTIVE: directionalBar
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'directionalBar', directionalBar );

  function directionalBar() {
    var directive = {
      restrict: 'E',
      scope: {},
      bindToController: {
        value: '=',
        max: '@',
        decimal: '@',
        unit: '@'
      },
      templateUrl: 'components/directional-bar/directional-bar.html',
      controller: directionalBarController,
      controllerAs: 'vm'
    };

    return directive;


    ////////////

    function directionalBarController() {
      var vm = this;

      vm.max = +vm.max;
      vm.decimal = +vm.decimal || 0;
      vm.value = round( vm.value, vm.decimal );
      vm.percent = 100 * ( Math.abs( vm.value ) / vm.max );
      vm.text = vm.unit ? ( vm.value + vm.unit ) : vm.value;

      ////////////

      function round( value, decimal ) {
        var pow = Math.pow( 10, decimal );
        return Math.round( value * pow ) / pow;
      }
    }

  }

} )();
