/**
 * DIRECTIVE: inputReactive
 * from https://github.com/mhartington/Ionic-Chat/blob/master/www/js/app.js
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'inputReactive', inputReactive );

  function inputReactive( $timeout ) {
    var directive = {
      restrict: 'A',
      scope: {
        'onReturn': '&'
      },
      link: linkFunc
    };

    return directive;


    ////////////

    function linkFunc( scope, element ) {

      var timer;

      element.bind( 'keydown', keyEnter );

      scope.$on( '$destroy', function() {
        $timeout.cancel( timer );
        element.unbind( 'keydown' );
      } );


      ////////////

      function keyEnter( e ) {
        if ( e.which !== 13 ) {
          return;
        }

        if ( scope.onReturn ) {
          timer = $timeout( function() {
            scope.onReturn();
          } );
        }
      }
    }

  }

} )();
