/**
 * DIRECTIVE: itemLink
 * @author Fabien Vauchelles <fabien@vauchelles.com>
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'itemLink', itemLink );

  function itemLink( $state ) {

    var directive = {
      restrict: 'E',
      templateUrl: 'components/item-link/item-link.html',
      scope: {},
      bindToController: {
        value: '=',
        placeholder: '@'
      },
      controller: ItemLinkController,
      controllerAs: 'vm'
    };

    ////////////

    /* @ngInject */
    function ItemLinkController() {
      if ( this.value ) {
        this.name = this.value.shortname || this.value.name || this.value.fullname || this.placeholder;
        this.fullName = this.value.fullname || this.value.name;

        if ( this.value.resourceType && this.value.id ) {

          // If access to that kind of item is restricted, make no link
          this.isLink = true;
        } else {
          this.isLink = false;
        }
      } else {
        //only set if not undefined but null
        this.name = this.placeholder || '-';
        this.fullName = this.name;
        this.isLink = false;
      }

      if ( this.isLink !== undefined ) {
        this.isNotLink = !( this.isLink );
      }
    }

    ItemLinkController.prototype.go = function go() {
      var stateName = 'session.' + this.value.resourceType;
      $state.go( stateName, {
        itemId: this.value.id,
        zoom: true
      } );
    };
    return directive;

  }

} )();

