/**
 * DIRECTIVE: kplerLogo
 * @author Marc Beuret <mbeuret@kpler.com>
 */

( function() {
  'use strict';

  angular
    .module( 'lng' )
    .directive( 'kplerLogo', kplerLogo );

  function kplerLogo( $ionicActionSheet, LoginService, SettingsService ) {
    var directive = {
      restrict: 'E',
      scope: {},
      templateUrl: 'components/kpler-logo/kpler-logo.html',
      controller: kplerLogoController,
      controllerAs: '$ctrl'
    };

    ////////////

    /* @ngInject */
    function kplerLogoController() {
      this.currentCommo = SettingsService.getSettings().COMMODITY;
      this.isLng = this.currentCommo === 'LNG';
      this.isLpg = this.currentCommo === 'LPG';
      this.isOil = this.currentCommo === 'OIL';
      this.$ionicActionSheet = $ionicActionSheet;
    }

    kplerLogoController.prototype.openMulticommo = function openMulticommo() {
      var hideSheet = this.$ionicActionSheet.show( {
        buttons: [
          { text: 'LNG', commodity: 'lng' },
          { text: 'LPG', commodity: 'lpg' },
          { text: 'OIL', commodity: 'oil' }
        ],
        titleText: 'Choose commodity',
        cancelText: 'Cancel',
        cancel: hideSheet,
        buttonClicked: function( index ) {
          var selected = this.buttons[ index ].commodity;
          hideSheet();
          LoginService.switchCommodity( selected );
          return true;
        },
        cssClass: 'kpler-action-sheet'
      } );

    };

    return directive;

  }

} )();
