/**
 * Map Helper
 * @author Yoann
 */

( function( global ) {
  'use strict';

  global.markerInstallationHelper = ( global.module || {} ).exports = {
    create: create,
    remove: remove
  };


  ////////////

  function create( map, installation, iconSharedConfig ) {

    var icon = global.markerIconHelper.iconConfigSpecific( installation, iconSharedConfig, 'installation' ),
      marker = new google.maps.Marker( {
        position: installation.$mapAttrs.$pos,
        map: map,
        icon: icon,
        zIndex: google.maps.Marker.MAX_ZINDEX + 1
      } );

    marker.$remove = removeMarker;
    // Dirty. For click handler.
    marker.$itemType = 'installation';
    marker.$type = installation.type;
    marker.$itemId = installation.id;

    map.$oms.addMarker( marker );

    return marker;

    ////////////

    function removeMarker() {
      this.setMap( null );
      if ( this.$tooltip ) {
        this.$tooltip.setMap( null );
      }
    }
  }

  function remove( map, item ) {
    var mapAttrs,
      marker;

    if ( item ) {

      mapAttrs = item.$mapAttrs;
      marker = mapAttrs.$marker;

      if ( marker ) {
        marker.setMap( null );
        map.$oms.removeMarker( marker );
      }
    }
  }

} )( this );
