/**
 * DIRECTIVE: Physical Quantity
 *   - Renders value + unit according to commodity and user settings
 *   - Subscribe to unitSettingsUpdated event (subscription removed when directive is destroyed)
 *
 *   Add doc
 *
 */

( function() {
  'use strict';

  angular
    .module( 'lng' )
    .directive( 'physicalQuantity', physicalQuantity );

  function physicalQuantity( $rootScope, PhysicalQuantityService ) {
    var directive = {
      restrict: 'A',
      scope: {},
      link: linkFunc
    };

    return directive;

    ////////////

    /* @ngInject */
    function linkFunc( scope, element, attrs ) {

      var value,
        options,
        unitsSettingslistener;

      value = scope.$eval( attrs.physicalQuantity ) || {};
      options = scope.$eval( attrs.physicalQuantityOptions ) || {};

      unitsSettingslistener = $rootScope.$on( 'unitsSettingsUpdated', renderUnit );

      renderUnit();

      scope.$on( '$destroy', unitsSettingslistener );

      ////////////

      /**
       *
       */
      function renderUnit() {
        element.html( PhysicalQuantityService.format( value, options ) );
      }

    }
  }

} )();
