/**
 * This file configure defaults units to use for display for each commodity
 * Display is split in two categories:
 *  - cargo: non aggregated data --> vessel capacity, installation capacity, load, discharge ...
 *  - aggregated: flows ...
 *
 * Unit id sent by the backend (MulticommoService.getAvailableUnits()) is used for configuration.
 * For readablity, unit name is added as a comment.
 * Check `commodity` table to have complete visibility of id <-> name mapping
 */

angular.module( 'lng' )
  .constant( 'UnitsConfig', {
    'default': {
      'lng': {
        'cargo': 'cm',
        'aggregated': 'mtons'
      },
      'lpg': {
        'cargo': 'ktons',
        'aggregated': 'mtons'
      },
      'oil': {
        'cargo': 'barrel',
        'aggregated': 'kb'
      }
    }
  } );
