/**
 * DIRECTIVE: Units
 *   - Renders a formatted unit according to commodity and user settings
 *   - Subscribe to unitSettingsUpdated event (subscription removed when directive is destroyed)
 *
 *   Add Doc
 *
 */

( function() {
  'use strict';

  angular
    .module( 'lng' )
    .directive( 'kpUnit', kpUnit );

  function kpUnit( $rootScope, PhysicalQuantityService ) {
    var directive = {
      restrict: 'A',
      scope: {},
      link: linkFunc
    };

    return directive;

    ////////////

    /* @ngInject */
    function linkFunc( scope, element, attrs ) {

      var options,
        unitsSettingslistener;

      options = scope.$eval( attrs.kpUnit ) || {};
      unitsSettingslistener = $rootScope.$on( 'unitsSettingsUpdated', render );

      render();

      scope.$on( '$destroy', unitsSettingslistener );

      ////////////

      /**
       *
       */
      function render() {
        element.html( PhysicalQuantityService.legend( options ) );
      }

    }
  }

} )();
