/**
 * DIRECTIVE: portcallForecasted
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'portcallForecasted', portcallForecasted );

  function portcallForecasted() {
    var directive = {
      restrict: 'E',
      scope: {},
      bindToController: {
        portcall: '='
      },
      templateUrl: 'components/portcall/forecasted/portcall-forecasted.html',
      controller: controllerFunc,
      controllerAs: 'vm'
    };

    return directive;


    ////////////

    /* @ngInject */
    function controllerFunc( MapCacheService, MulticommoService ) {
      var vm = this,
        i,
        forecastedTreeLen,
        forecastedTree,
        maxVesselCapacity;

      vm.portcall = this.portcall;
      vm.showButtons = showButtons;
      vm.toggleNode = toggleNode;

      // Adjust cargo gauge according to commodity
      // MB @todo:
      //   - Replace directional-bar by physical-gauge directive
      //   - Remove / 1000 calculation from there, we should pass the maxVesselCapacity object, define the unit to display
      //     and let the directive doing the job.
      maxVesselCapacity = MapCacheService.getFleetMetrics().cargoQuantity.max;
      vm.maxCapacity = MulticommoService.getCurrentCommodity().name === 'lng'
        ? maxVesselCapacity.volume / 1000
        : maxVesselCapacity.quantity / 1000;

      forecastedTree = vm.portcall.forecastedTree || [];

      forecastedTreeLen = forecastedTree.length;
      for ( i = 0; i < forecastedTreeLen; i++ ) {
        initNode( forecastedTree[ i ], 0 );
      }

      ////////////

      function initNode( node, depth ) {
        var j = 0,
          len;

        node.depth = depth;
        node.depthPadding = ( node.depth * 10 ) + 'px';
        node.expanded = false;

        if ( node.children ) {
          len = node.children.length;
          for ( j = 0; j < len; j++ ) {
            initNode( node.children[ j ], depth + 1 );
          }
        }
      }

      function showButtons( node ) {
        return node.children && node.children.length > 0;
      }

      function toggleNode( node ) {
        node.expanded = !node.expanded;
      }
    }
  }

} )();
