/**
 * DIRECTIVE: tabsActive
 * @author Yoann
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'tabsActive', tabsActive );

  function tabsActive() {
    var directive = {
      restrict: 'A',
      link: linkFunc
    };

    return directive;


    ////////////

    function linkFunc( scope, el, attrs ) {
      var children = el.children();

      scope.$watch( attrs.tabsActive, updateActiveTab );


      ////////////

      function updateActiveTab( activeIndex ) {
        var i,
          len = children.length,
          childEl;

        if ( _.isUndefined( activeIndex ) ) {
          return;
        }

        for ( i = 0; i < len; i++ ) {
          childEl = angular.element( children[ i ] );

          if ( i === activeIndex ) {
            childEl.addClass( 'active' );
          } else {
            childEl.removeClass( 'active' );
          }
        }
      }

    }
  }

} )();
