/**
 * DIRECTIVE: trades
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .directive( 'trades', trades );

  function trades( $stateParams, TradesService ) {

    var page,
      self,
      directive = {
        restrict: 'E',
        scope: {},
        bindToController: {
          promise: '=',
          type: '@'
        },
        templateUrl: 'components/trades/trades.html',
        controller: TradesController,
        controllerAs: 'vm'
      };

    ////////////

    /* @ngInject */
    function TradesController( $scope, TrackService ) {

      self = this;
      page = 0;

      this.scope = $scope;
      this.entity = null;
      this.trades = [];
      this.loadMoreVisible = true;
      this.promise
        .then( track )
        .then( this.loadMore );


      ////////////

      function track( entity ) {
        var title = self.type + ' ' + entity.name + ' (' + entity.id + ') - Trades',
          trackObj = {
            route: self.type + '/trades',
            title: title
          };
        trackObj[ self.type + '_id' ] = entity.id;
        trackObj[ self.type + '_name' ] = entity.name;

        TrackService.track( trackObj );
        return entity;
      }

    }

    TradesController.prototype.loadMore = function loadMore() {
      var type = self.type + 's';

      return TradesService.load(
        $stateParams.itemId,
        page++,
        undefined,
        type
      )
        .then( addTrades )
        .then( notifyInfiniteScrollComplete );


      ////////////

      function addTrades( tradesObj ) {
        var i = 0,
          len = tradesObj.length;

        for ( i; i < len; i++ ) {
          addTrade( tradesObj[ i ] );
        }

        self.loadMoreVisible = tradesObj.length > 0;

        return tradesObj;


        ////////////

        function addTrade( trade ) {
          self.trades.push( trade );
        }
      }

      function notifyInfiniteScrollComplete() {
        self.scope.$broadcast( 'scroll.infiniteScrollComplete' );
      }
    };

    return directive;

  }

} )();
