/**
 * SERVICE: TradesService
 */

( function() {
  'use strict';


  angular
    .module( 'lng' )
    .factory( 'TradesService', TradesService );

  function TradesService( $window, Restangular ) {

    var factory = {
      load: load
    };

    return factory;


    ////////////

    function load( id, page, cancelPromise, type ) {

      var items,
        pageSize,
        promise;

      items = {
        minimumRequested: 25,
        // A row height
        pixelHeight: 86
      };

      pageSize = Math.max(
        items.minimumRequested,
        Math.round( $window.innerHeight / items.pixelHeight )
      );

      promise = Restangular.one( type, id );

      if ( cancelPromise ) {
        promise = promise.withHttpConfig( { timeout: cancelPromise } );
      }

      return promise.getList( 'trades', {
        from: page * pageSize,
        size: pageSize,
        withForecasted: false
      } )
        .then( updateTrades );


      //////////

      function updateTrades( trades ) {
        var i = 0,
          len = trades.length;

        for ( i; i < len; i++ ) { update( trades[ i ] ); }

        return trades;

        ////////////

        function update( trade ) {
          if ( trade.start ) { trade.start = moment.utc( trade.start ); }
          if ( trade.end ) { trade.end = moment.utc( trade.end ); }
        }
      }
    }
  }

} )();
